local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_MiscHelper"

local defaults = {
	['test'] = false,
	['sellgrey'] = true,
	['noduel'] = true,
	['autorepair'] = true,
	['hideclock'] = true,
}

local options = {
}

addon['mhmods'] = addon['mhmods'] or {}

local mods = {}
local events = {}
local registered = {}
local db = {}
-- addon['addCharDefaults'](childName,'global', defaults)

local function eventHandler(self, event, ...)
	for k,v in pairs(mods) do
		if(type(events[v][event]) == 'function' and db[v]) then
			events[v][event](event, ...)
		end
	end
end
local inited = {}
local function iterateModuls()
	for _, modul in ipairs(addon['mhmods']) do
		mods[#mods + 1] = modul['name']
		for _, event in ipairs(modul['events']) do
			events[modul['name']] = { [event] = modul['onevent']}

			if(not registered[event]) then
				registered[event] = true
				addon['RegisterFunc'](event, "OnEvent", eventHandler)
			end
		end
		addon['AddConfigEntry'](addon, childName, "toggle",modul['name'],modul['message'],nil,1,nil,nil,nil,nil,options['args'][childName])
		if(type(modul['init']) == 'function' and db[modul['name']]) then
			modul['init']()
			inited[modul['name']] = true
		end
	end
end

addon['MH_GetPref'] = function(key)
	return db[key]
end

addon['MH_GetDB'] = function(subTable, def)
	if(not subTable) then return db end
	def = def or {}
	local key = subTable.."Settings"
	db[key] = db[key] or CopyTable(def)
	return db[key]
end

addon['MH_SetPref'] = function(key, value)
	db[key] = value
end

addon['MH_GetOptions'] = function()
	return options
end

local function getPref(pref)
	return db[pref[#pref]]
end

local function setPref(pref,value)
	db[pref[#pref]] = value
	if(value and not inited[pref[#pref]]) then
--		print(pref[#pref])
		for _, modul in ipairs(addon['mhmods']) do
			if(modul['name'] == pref[#pref]) then
				if(type(modul['init']) == 'function') then
					modul['init']()
					break
				end
			end
		end
	end
end

local function init()
	options = addon['InitConfig'](addon, childName, true, {
		['name'] = childName,
		['typ'] = 'launcher',
	}, getPref, setPref)
	db = addon['db']['profile'][childName]
	iterateModuls()
end

addon['startup'](addon, name, childName, init, false, defaults)